<?php
class AddedIsActiveAndIsRemovedColumnsToProducts extends CakeMigration {

/**
 * Migration description
 *
 * @var string
 */
	public $description = '';

/**
 * Actions to be performed
 *
 * @var array $migration
 */
	public $migration = array(
		'up' => array(
			'alter_field' => array(
				'ev_shop_brands' => array(
					'id' => array('type' => 'integer', 'null' => false, 'default' => null, 'unsigned' => false, 'key' => 'primary'),
				),
				'ev_shop_product_attribute_options' => array(
					'id' => array('type' => 'integer', 'null' => false, 'default' => null, 'unsigned' => false, 'key' => 'primary'),
					'product_attribute_id' => array('type' => 'integer', 'null' => false, 'default' => null, 'unsigned' => false, 'key' => 'index'),
					'sequence' => array('type' => 'integer', 'null' => true, 'default' => null, 'unsigned' => false),
				),
				'ev_shop_product_attribute_options_product_variants' => array(
					'id' => array('type' => 'integer', 'null' => false, 'default' => null, 'unsigned' => false, 'key' => 'primary'),
					'product_attribute_option_id' => array('type' => 'integer', 'null' => false, 'default' => null, 'unsigned' => false, 'key' => 'primary'),
					'product_variant_id' => array('type' => 'integer', 'null' => false, 'default' => null, 'unsigned' => false, 'key' => 'primary'),
				),
				'ev_shop_product_attribute_options_products' => array(
					'id' => array('type' => 'integer', 'null' => false, 'default' => null, 'unsigned' => false, 'key' => 'primary'),
					'product_attribute_option_id' => array('type' => 'integer', 'null' => false, 'default' => null, 'unsigned' => false, 'key' => 'index'),
					'product_id' => array('type' => 'integer', 'null' => false, 'default' => null, 'unsigned' => false, 'key' => 'index'),
				),
				'ev_shop_product_attributes' => array(
					'id' => array('type' => 'integer', 'null' => false, 'default' => null, 'unsigned' => false, 'key' => 'primary'),
				),
				'ev_shop_product_variants' => array(
					'id' => array('type' => 'integer', 'null' => false, 'default' => null, 'unsigned' => false, 'key' => 'primary'),
					'product_id' => array('type' => 'integer', 'null' => false, 'default' => null, 'unsigned' => false, 'key' => 'index'),
					'price' => array('type' => 'float', 'null' => true, 'default' => null, 'length' => '13,2', 'unsigned' => false),
					'rrp' => array('type' => 'float', 'null' => true, 'default' => null, 'length' => '13,2', 'unsigned' => false),
					'stock' => array('type' => 'integer', 'null' => true, 'default' => null, 'unsigned' => false),
				),
				'ev_shop_products' => array(
					'id' => array('type' => 'integer', 'null' => false, 'default' => null, 'unsigned' => false, 'key' => 'primary'),
					'vat_rate_id' => array('type' => 'integer', 'null' => true, 'default' => '1', 'unsigned' => false),
				),
			),
			'create_field' => array(
				'ev_shop_products' => array(
					'is_active' => array('type' => 'boolean', 'null' => false, 'default' => '1', 'after' => 'is_featured'),
					'is_removed' => array('type' => 'boolean', 'null' => false, 'default' => '0', 'after' => 'is_active'),
				),
			),
		),
		'down' => array(
			'alter_field' => array(
				'ev_shop_brands' => array(
					'id' => array('type' => 'integer', 'null' => false, 'default' => null, 'key' => 'primary'),
				),
				'ev_shop_product_attribute_options' => array(
					'id' => array('type' => 'integer', 'null' => false, 'default' => null, 'key' => 'primary'),
					'product_attribute_id' => array('type' => 'integer', 'null' => false, 'default' => null, 'key' => 'index'),
					'sequence' => array('type' => 'integer', 'null' => true, 'default' => null),
				),
				'ev_shop_product_attribute_options_product_variants' => array(
					'id' => array('type' => 'integer', 'null' => false, 'default' => null, 'key' => 'primary'),
					'product_attribute_option_id' => array('type' => 'integer', 'null' => false, 'default' => null, 'key' => 'primary'),
					'product_variant_id' => array('type' => 'integer', 'null' => false, 'default' => null, 'key' => 'primary'),
				),
				'ev_shop_product_attribute_options_products' => array(
					'id' => array('type' => 'integer', 'null' => false, 'default' => null, 'key' => 'primary'),
					'product_attribute_option_id' => array('type' => 'integer', 'null' => false, 'default' => null, 'key' => 'index'),
					'product_id' => array('type' => 'integer', 'null' => false, 'default' => null, 'key' => 'index'),
				),
				'ev_shop_product_attributes' => array(
					'id' => array('type' => 'integer', 'null' => false, 'default' => null, 'key' => 'primary'),
				),
				'ev_shop_product_variants' => array(
					'id' => array('type' => 'integer', 'null' => false, 'default' => null, 'key' => 'primary'),
					'product_id' => array('type' => 'integer', 'null' => false, 'default' => null, 'key' => 'index'),
					'price' => array('type' => 'float', 'null' => true, 'default' => null, 'length' => '13,2'),
					'rrp' => array('type' => 'float', 'null' => true, 'default' => null, 'length' => '13,2'),
					'stock' => array('type' => 'integer', 'null' => true, 'default' => null),
				),
				'ev_shop_products' => array(
					'id' => array('type' => 'integer', 'null' => false, 'default' => null, 'key' => 'primary'),
					'vat_rate_id' => array('type' => 'integer', 'null' => true, 'default' => '1'),
				),
			),
			'drop_field' => array(
				'ev_shop_products' => array('is_active', 'is_removed',),
			),
		),
	);

/**
 * Before migration callback
 *
 * @param string $direction, up or down direction of migration process
 * @return boolean Should process continue
 */
	public function before($direction) {
		return true;
	}

/**
 * After migration callback
 *
 * @param string $direction, up or down direction of migration process
 * @return boolean Should process continue
 */
	public function after($direction) {
		return true;
	}
}
